Bug 1899550 - python-wsaccel fails to build with Python 3.10: Avoid using PyObject_AsCharBuffer(), PyObject_AsReadBuffer() and PyObject_AsWriteBuffer()
Summary: python-wsaccel fails to build with Python 3.10: Avoid using PyObject_AsCharBu...
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: python-wsaccel
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Julien Enselme
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-19 14:19 UTC by Tomáš Hrnčiar
Modified: 2021-02-09 16:24 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github methane wsaccel issues 22 0 None closed deprecated buffer protocol API 2021-01-19 13:32:33 UTC

Description Tomáš Hrnčiar 2020-11-19 14:19:06 UTC
python-wsaccel fails to build with Python 3.10.0a2.

==================================== ERRORS ====================================
_______________________ ERROR collecting tests/test_4.py _______________________
ImportError while importing test module '/builddir/build/BUILD/wsaccel-0.6.2/tests/test_4.py'.
Hint: make sure your test modules/packages have valid Python names.
Traceback:
/usr/lib64/python3.10/importlib/__init__.py:126: in import_module
    return _bootstrap._gcd_import(name[level:], package, level)
tests/test_4.py:2: in <module>
    import wsaccel.utf8validator
E   ImportError: /builddir/build/BUILD/wsaccel-0.6.2/build/lib.linux-x86_64-3.10/wsaccel/utf8validator.cpython-310-x86_64-linux-gnu.so: undefined symbol: PyObject_AsReadBuffer
____________________ ERROR collecting tests/test_xormask.py ____________________
ImportError while importing test module '/builddir/build/BUILD/wsaccel-0.6.2/tests/test_xormask.py'.
Hint: make sure your test modules/packages have valid Python names.
Traceback:
/usr/lib64/python3.10/importlib/__init__.py:126: in import_module
    return _bootstrap._gcd_import(name[level:], package, level)
tests/test_xormask.py:1: in <module>
    from wsaccel.xormask import XorMaskerSimple
E   ImportError: /builddir/build/BUILD/wsaccel-0.6.2/build/lib.linux-x86_64-3.10/wsaccel/xormask.cpython-310-x86_64-linux-gnu.so: undefined symbol: PyObject_AsReadBuffer
=========================== short test summary info ============================
ERROR tests/test_4.py
ERROR tests/test_xormask.py
!!!!!!!!!!!!!!!!!!! Interrupted: 2 errors during collection !!!!!!!!!!!!!!!!!!!!
============================== 2 errors in 0.07s ===============================

https://docs.python.org/3.10/whatsnew/changelog.html#id16

bpo-41103: PyObject_AsCharBuffer(), PyObject_AsReadBuffer(), PyObject_CheckReadBuffer(), and PyObject_AsWriteBuffer() are removed. Please migrate to new buffer protocol; PyObject_GetBuffer() and PyBuffer_Release().

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01773479-python-wsaccel/

For all our attempts to build python-wsaccel with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-wsaccel/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Tomáš Hrnčiar 2020-12-04 10:03:34 UTC
Reported in upstream.

https://github.com/methane/wsaccel/issues/22

Comment 2 Tomáš Hrnčiar 2021-01-19 14:09:21 UTC
v0.6.3 fixes this issue, I have opened PR.

https://src.fedoraproject.org/rpms/python-wsaccel/pull-request/2

Comment 3 Ben Cotton 2021-02-09 15:26:09 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.


Note You need to log in before you can comment on or make changes to this bug.